<script>
	import PKCE from "js-pkce"
	import { getContext } from "svelte"
	import { browser } from "$app/env"
	import { page } from "$app/stores"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	import * as storage from "$lib/infrastructure/storage"

	async function handleLogin() {
		const context = getContext(AUTH_CONTEXT_KEY)
		const pkce = new PKCE(context.pkceConfig)
		const returnTo = $page.query.get("returnTo")
		if (returnTo) {
			storage.setReturnTo(returnTo)
		}
		// Do not use SvelteKit goto function to force a full page reload.
		window.location.replace(pkce.authorizeUrl())
	}

	if (browser) {
		handleLogin()
	}
</script>

<slot />
